

//STEP 1. Import required packages
import java.sql.*;
import java.util.ArrayList;

// TODO: Auto-generated Javadoc
/****
*La clase Database permite la conexin entre el programa y la base de datos externa
*@author Felipe Silva 
*@author Mario Marin
*@see Main
*
*///
public class Database {
   
   /** The JDBC driver name and database URL */
   static final String JDBC_DRIVER = "com.mysql.jdbc.Driver";  
   
   /** The Database URL. */
   static final String DB_URL = "jdbc:mysql://sql5.freemysqlhosting.net/sql5126180";

   /** The Database credentials. */
   static final String USER = "sql5126180";
   
   /** The Database Password */
   static final String PASS = "R5CzHsPsZT";
   
   /** The username. */
   private String username = "";
   
   /** The Name. */
   private String Name = "";
   
   /** The id. */
   private int id=-1;
   
   /** The texts of the logged user. */
   private ArrayList texts;
   
   /** If logged boolean. */
   private boolean is_logged=false;
   
   /**
    * Checks if the user is logged.
    *
    * @return true, if is logged
    */
   public boolean isLogged(){
	   return is_logged;
   }
   
   /**
    * Gets the id.
    *
    * @return the id
    */
   public int getId(){
	   return id;
   }
   
   /**
    * Gets the name.
    *
    * @return the name
    */
   public String getName(){
	   return Name;
   }
   
   /**
    * Sets the username.
    *
    * @param newuser the username from the database
    */
   public void setUsername(String newuser){
	   username = newuser;
   }
   
   /**
    * Logout.
    */
   public void logout(){
	   username = "";
	   Name = "";
	   id=-1;
	   texts =null;;
	   is_logged=false;
   }
   
   /**
    * Update data to the database.
    *
    * @param note_id the note id
    * @param note_encrypt the content of the note
    */
   public void updateData(int note_id, String note_encrypt){
	   Connection conn = null;
	   Statement stmt = null;
	   if(is_logged){
	   try{
	      //STEP 2: Register JDBC driver
	      Class.forName("com.mysql.jdbc.Driver");

	      //STEP 3: Open a connection
	      //System.out.println("Connecting to a selected database...");
	      conn = DriverManager.getConnection(DB_URL, USER, PASS);
	      //System.out.println("Connected database successfully...");
	      
	      //STEP 4: Execute a query
	      //System.out.println("Creating statement...");
	      stmt = conn.createStatement();
	      String sql = "UPDATE note " +
	                   "SET note_encrypt = '"+note_encrypt+"' WHERE note_id="+note_id;
	      stmt.executeUpdate(sql);

	   }catch(SQLException se){
	      //Handle errors for JDBC
	      se.printStackTrace();
	   }catch(Exception e){
	      //Handle errors for Class.forName
	      e.printStackTrace();
	   }finally{
	      //finally block used to close resources
	      try{
	         if(stmt!=null)
	            conn.close();
	      }catch(SQLException se){
	      }// do nothing
	      try{
	         if(conn!=null)
	            conn.close();
	      }catch(SQLException se){
	         se.printStackTrace();
	      }//end finally try
	   }//end try
	   }//System.out.println("Goodbye!");
   }
   
   /**
    * Delete data from the database .
    *
    * @param element_id the note id
    */
   public void deleteData(int element_id){
	   Connection conn = null;
	   Statement stmt = null;
	   if(is_logged){
	   try{
	      //STEP 2: Register JDBC driver
	      Class.forName("com.mysql.jdbc.Driver");

	      //STEP 3: Open a connection
	      //System.out.println("Connecting to a selected database...");
	      conn = DriverManager.getConnection(DB_URL, USER, PASS);
	      //System.out.println("Connected database successfully...");
	      
	      //STEP 4: Execute a query
	      //System.out.println("Creating statement...");
	      stmt = conn.createStatement();
	      String sql = "DELETE FROM user_notes " +
	                   "WHERE note_id="+element_id;
	      stmt.executeUpdate(sql);
	      sql = "DELETE FROM note " +
                  "WHERE note_id="+element_id;
	      stmt.executeUpdate(sql);
	   }catch(SQLException se){
	      //Handle errors for JDBC
	      se.printStackTrace();
	   }catch(Exception e){
	      //Handle errors for Class.forName
	      e.printStackTrace();
	   }finally{
	      //finally block used to close resources
	      try{
	         if(stmt!=null)
	            conn.close();
	      }catch(SQLException se){
	      }// do nothing
	      try{
	         if(conn!=null)
	            conn.close();
	      }catch(SQLException se){
	         se.printStackTrace();
	      }//end finally try
	   }//end try
	   }//System.out.println("Goodbye!");
   }
   
   /**
    * Create a new note.
    *
    * @param title the title of the note
    * @return the id of the note created
    */
   public Integer new_file(String title){
	   Connection conn = null;
	   Statement stmt = null;
	   Integer note_id=-1;
	   if(is_logged){
	   try{
	      //STEP 2: Register JDBC driver
	      Class.forName("com.mysql.jdbc.Driver");

	      //STEP 3: Open a connection
	      //System.out.println("Connecting to database...");
	      conn = DriverManager.getConnection(DB_URL,USER,PASS);

	      //STEP 4: Execute a query
	      //System.out.println("Creating statement...");
	      stmt = conn.createStatement();
	      String sql;
	      sql = "INSERT INTO note (note_title) " +
	              "VALUES ('"+title+"')";
	      
	      //sql = "SELECT id, first, last, age FROM Employees";
	      int rs = stmt.executeUpdate(sql,Statement.RETURN_GENERATED_KEYS);
	      ResultSet generatedKeys = stmt.getGeneratedKeys();
	      if (generatedKeys.next()) {
	    	  note_id = generatedKeys.getInt(1);
	    	  sql = "INSERT INTO user_notes (user_id, note_id) " +
		              "VALUES ('"+id+"',"+note_id+")";
	    	  rs = stmt.executeUpdate(sql);
          }
	      //rs.close();
	      stmt.close();
	      conn.close();
	   }catch(SQLException se){
	      //Handle errors for JDBC
	      se.printStackTrace();
	   }catch(Exception e){
	      //Handle errors for Class.forName
	      e.printStackTrace();
	   }finally{
	      //finally block used to close resources
	      try{
	         if(stmt!=null)
	            stmt.close();
	      }catch(SQLException se2){
	      }// nothing we can do
	      try{
	         if(conn!=null)
	            conn.close();
	      }catch(SQLException se){
	         se.printStackTrace();
	      }//end finally try
	   }}//end try
	   return note_id;
	}//end main
   
   /**
    * Bring data from the database to the program.
    *
    * @return an Archivo Class with all the data
    */
   public Archivo bring_data(){
	   Connection conn = null;
	   Statement stmt = null;
	   Archivo files = new Archivo();
	   if(is_logged){
	   try{
	      //STEP 2: Register JDBC driver
	      Class.forName("com.mysql.jdbc.Driver");

	      //STEP 3: Open a connection
	      //System.out.println("Connecting to a selected database...");
	      conn = DriverManager.getConnection(DB_URL, USER, PASS);
	      //System.out.println("Connected database successfully...");
	      
	      //STEP 4: Execute a query
	      //System.out.println("Creating statement...");
	      stmt = conn.createStatement();

	      String sql = "SELECT note.note_id, note.note_title, note.note_encrypt, user_notes.user_id, user_notes.note_id "
	      		+ "FROM note INNER JOIN user_notes ON  note.note_id=user_notes.note_id WHERE user_id="+id;
	      ResultSet rs = stmt.executeQuery(sql);
	      //STEP 5: Extract data from result set
	      while(rs.next()){
	         //Retrieve by column name
	    	  Integer note_id = new Integer(rs.getInt("note_id"));
	    	  String note_title = new String(rs.getString("note_title"));
	    	  
	    	  String note_encrypt =new String(rs.getString("note_encrypt")==null? "":rs.getString("note_encrypt"));
	         files.addArchivo(note_id, note_title, note_encrypt);
	      }
	      rs.close();
	   }catch(SQLException se){
	      //Handle errors for JDBC
	      se.printStackTrace();
	   }catch(Exception e){
	      //Handle errors for Class.forName
	      e.printStackTrace();
	   }finally{
	      //finally block used to close resources
	      try{
	         if(stmt!=null)
	            conn.close();
	      }catch(SQLException se){
	      }// do nothing
	      try{
	         if(conn!=null)
	            conn.close();
	      }catch(SQLException se){
	         se.printStackTrace();
	      }//end finally try
	   }}//end try
	   return files;
	}//end main
   
   /**
    * Login user.
    *
    * @param args the username and password
    * @return true, if successful
    */
   public boolean login_user(String[] args){
		   Connection conn = null;
		   Statement stmt = null;
		   String name = args[0];
		   String password = args[1];
		   String databaseUsername="";
		   String databasePassword="";
		   String databaseName="";
		   int databaseid=id;
		   try{
		      //STEP 2: Register JDBC driver
		      Class.forName("com.mysql.jdbc.Driver");

		      //STEP 3: Open a connection
		      //System.out.println("Connecting to database...");
		      conn = DriverManager.getConnection(DB_URL,USER,PASS);

		      //STEP 4: Execute a query
		      //System.out.println("Creating statement...");
		      stmt = conn.createStatement();
		      String SQL = "SELECT * FROM user WHERE user_nickname='" + args[0] + "' && user_password=PASSWORD('" + args[1]+ "')";

		      ResultSet rs = stmt.executeQuery(SQL);

		              // Check Username and Password
		      if(rs.next()) {
		          databaseUsername = rs.getString("user_nickname");
		          databasePassword = rs.getString("user_password");
		      }

		      if (name.equals(databaseUsername)) {
		          setUsername(databaseUsername);
		          Name = rs.getString("user_name");
		          id = rs.getInt("user_id");
		          is_logged=true;
		          //System.out.println("Successful Login!\n----");
		      } else {
		          System.out.println("Incorrect Password\n----");
		      }

		      rs.close();
		      stmt.close();
		      conn.close();
		   }catch(SQLException se){
		      //Handle errors for JDBC
		      se.printStackTrace();
		   }catch(Exception e){
		      //Handle errors for Class.forName
		      e.printStackTrace();
		   }finally{
		      //finally block used to close resources
		      try{
		         if(stmt!=null)
		            stmt.close();
		      }catch(SQLException se2){
		      }// nothing we can do
		      try{
		         if(conn!=null)
		            conn.close();
		      }catch(SQLException se){
		         se.printStackTrace();
		      }//end finally try
		   }//end try
		   //System.out.println("Goodbye!");
		if (id != -1){
			return true;
		}
		else{
			return false;
		}
		}//end main
   
   /**
    * Creates the user.
    *
    * @param args the form data
    */
   public static void create_user(String[] args) {
   Connection conn = null;
   Statement stmt = null;
   try{
      //STEP 2: Register JDBC driver
      Class.forName("com.mysql.jdbc.Driver");

      //STEP 3: Open a connection
      //System.out.println("Connecting to database...");
      conn = DriverManager.getConnection(DB_URL,USER,PASS);

      //STEP 4: Execute a query
      //System.out.println("Creating statement...");
      stmt = conn.createStatement();
      String sql;
      sql = "INSERT INTO user (user_name, user_email, user_nickname, user_password) " +
              "VALUES ('"+args[0].toString()+"', '"+args[1].toString()+"', '"+args[2].toString()+"', PASSWORD('"+args[3].toString()+"'))";
      
      //sql = "SELECT id, first, last, age FROM Employees";
      int rs = stmt.executeUpdate(sql);

      //rs.close();
      stmt.close();
      conn.close();
   }catch(SQLException se){
      //Handle errors for JDBC
      se.printStackTrace();
   }catch(Exception e){
      //Handle errors for Class.forName
      e.printStackTrace();
   }finally{
      //finally block used to close resources
      try{
         if(stmt!=null)
            stmt.close();
      }catch(SQLException se2){
      }// nothing we can do
      try{
         if(conn!=null)
            conn.close();
      }catch(SQLException se){
         se.printStackTrace();
      }//end finally try
   }//end try
   //System.out.println("Goodbye!");
}//end main
}//end FirstExample