import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

/*
 * Created by JFormDesigner on Fri Jun 10 20:54:33 GMT-04:00 2016
 */

/**
 * 
 * La clase interfaz_grafica es la columna de el proyecto, 
 * manejando una porcion no menor de la logica de este, 
 * esto se debe en gran medida a que los action listeners de la interfaz
 *  se encuentra implementada en esta clase.
 *  
 * @author mario marin 
 * @author felipe silva
 * @see SystemClipboard
 * @see new_file
 * @see login_popup
 * 
 */
public class interfaz_grafica extends JFrame {
	Database usuario;
	public interfaz_grafica() {
		usuario = new Database();
		datos = new Archivo();
		initComponents();
	}
	static boolean toggle = false;
	
	/**
	 * Guarda localmente el archivo editado, esto se esto es solo temporal.
	 */
	public void save(){
		try {
			FileWriter out=null;
            File file = new File("src/temp/"+openFile);
            out = new FileWriter(file);     
            out.write(editorPanel.getText());
            out.close();
        } catch (FileNotFoundException e1) {
            e1.printStackTrace();
        } catch (IOException e1) {
            e1.printStackTrace();
        }
	}
	/**
	 * Guarda los contenidos de el archivo entregado por parametro en el arreiglo "content", 
	 * el cual lugo sera subido a la base de datos
	 * @param file_name es el nombre de el archivo que se desea guardar
	 */
	public void save_to_content(String file_name){
		Path path = Paths.get("src/temp/"+file_name);
		//File file = new File("src/temp/"+file_name);
		int location = data.indexOf(file_name); 
		java.util.List<String> lines=null;
		String temp;
		try {
			lines = Files.readAllLines(path);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		temp = String.join("\n", lines);
		
		content.set(location, temp);
		
		
	}
	/**
	 * Actualiza la lista grafica de archivos disponibles para edicion. 
	 * @param lista Corresponde a la lista actualizada de archivos.
	 */
	
	public void update_list(ArrayList lista){
		data = lista;
		if(data==null){
			list1 = new JList();
			 list1.addListSelectionListener(e2 ->list1ValueChanged(e2));
			 scrollPane1.setViewportView(list1);
		}else{
		list1 = new JList(data.toArray());
		 list1.addListSelectionListener(e2 ->list1ValueChanged(e2));
		 scrollPane1.setViewportView(list1);
		}
	}
	
	public void delete_text(){
		editorPanel.setText("");
	}
	
	
	/**
	 * Este metodo abre y despliega graficamente el archivo indicado por "openFile".
	 */
	public void open(){
		BufferedReader in;
		try {
			in = new BufferedReader(new FileReader("src/temp/"+openFile));
			String line = in.readLine();
			while(line != null){
			  editorPanel.append(line + "\n");
			  line = in.readLine();
			}
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	/**
	 * Elimina el contenido de todos los archivos almacenados localmente, 
	 * esto se ejecuta cuando se preciona "logout"
	 */
	public void purge_files(){
		for(Object i : data.toArray()){
			openFile = i.toString();
			is_a_file_open = true;
			open();
			delete_text();
			save();
		}
	}
/**
 * Este ActionListener abre el archivo seleccionado por el usuario de la lista.
 * 
 */
	public void list1ValueChanged(ListSelectionEvent e) {//lista
		
		Object nombre =list1.getSelectedValue();
		toggle = !toggle;
		
		if (toggle == true){
			if(is_a_file_open == true){
				save();
				delete_text();
				openFile = nombre.toString();
				is_a_file_open = true;
				open();
			}
			
			else{
				openFile = nombre.toString();
				is_a_file_open = true;
				open();
			}
		}
		
		
		
	}
/**
 *  Este ActionListener sincroniza las ediciones de el usuario con la base de datos
 * 
 */
	private void button1ActionPerformed(ActionEvent e) {//save
		// TODO add your code here
		save();
		for (Object i :data){
			save_to_content(i.toString());
		}
		
		for(int i=0;i<content.size();i++ ){
			usuario.updateData(Integer.parseInt(id.toArray()[i].toString()),content.toArray()[i].toString());
		}
		//SE DEVE AGREGAR EL COMANDO UPDATE
		
	}
/**
 * Este ActionListener abre el popup que permite el login con la base de datos, 
 * si el login fue exitoso, el metodo descarga todos los archivos associados
 *  a la cuenta de el usuario, para que este los pueda editar, 
 *  cabe destacar que esto se hace solo de manera temporal.
 * 
 */
	private void button2ActionPerformed(ActionEvent e) {//login
		// TODO add your code here
		login_popup login = new login_popup(usuario);
		login.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		login.setLocationByPlatform(true);
		login.setModal(true);
		login.setVisible(true);
		
		///el usuario inicia sesion
		if (usuario.isLogged()){
			datos = usuario.bring_data();
			data = datos.getTitle();
			content = datos.getContent();
			id = datos.getId();
			update_list(data);
			
			FileWriter out=null;
			File file;
			int id;
			if(data==null){
				
			}
			else{
				for(Object temp : data){
					
					id = data.indexOf(temp);
					file = new File("src/temp/"+temp);
					try {
						file.createNewFile();
						 out = new FileWriter(file);     
				         out.write(content.toArray()[id].toString());
				         out.close();
					} catch (IOException e1) {
						
						e1.printStackTrace();
					}
				}
			}
		}
		
		
	}
/**
 * Este ActionListener elimina el archivo actualmente abierto por el usuario.
 * 
 */
	private void menuItem1ActionPerformed(ActionEvent e) {//delete
		int potition = data.indexOf(openFile); 
		data.remove(openFile);
		 list1 = new JList(data.toArray());
		 list1.addListSelectionListener(e2 -> list1ValueChanged(e2));
		 scrollPane1.setViewportView(list1);
	
		 usuario.deleteData(Integer.parseInt(id.toArray()[potition].toString()));
		 content.remove(potition);
		 id.remove(potition);
		 delete_text();
		 save();

	}
	/**
	 *  Este ActionListener realiza un logout con la base de datos, 
	 *  ademas elimina el contenido de todos los archivos temporales usados por la aplicacion.
	 * 
	 */

	private void menuItem2ActionPerformed(ActionEvent e) {//logout
		// TODO add your code here
		purge_files();
		usuario.logout();
		id.clear();
		content.clear();
		data.clear();
		 list1 = new JList();
		 list1.addListSelectionListener(e2 -> list1ValueChanged(e2));
		 scrollPane1.setViewportView(list1);
	}
/**
 * Copia el texto selecionado al portapapeles
 * 
 */
	private void menuItem3ActionPerformed(ActionEvent e) {//copy
		// TODO add your code here
		try {
		
			SystemClipboard.copy(new StringSelection(editorPanel.getSelectedText()));
			
		} catch (HeadlessException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} 
		
	}
	/**
	 * Pega el texto almacenado en el portapapeles.
	 * 
	 */

	private void menuItem4ActionPerformed(ActionEvent e) {//paste
		// TODO add your code here
		
		try {
			SystemClipboard.paste();
		} catch (AWTException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	/**
	 * Este ActionListener despliega el popup de creacion de nuevo archivo.
	 * 
	 */
	private void menuNewActionPerformed(ActionEvent e){//New
		
		save();
		JFrame pop_up = new new_file(this,usuario);
		pop_up.setVisible(true);
		
	}
/**
 * Este metodo inicializa la interfaz grafica.
 */
	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		// Generated using JFormDesigner Evaluation license - mario marin
		dialogPane = new JPanel();
		contentPanel = new JPanel();
		scrollPane1 = new JScrollPane();
		data = new ArrayList();
		list1 = new JList( data.toArray());
		panel1 = new JPanel();
		button1 = new JButton();
		button2 = new JButton();
		menuBar1 = new JMenuBar();
		menu1 = new JMenu();
		menuItem1 = new JMenuItem();
		menuItem2 = new JMenuItem();
		menu2 = new JMenu();
		menuItem3 = new JMenuItem();
		menuItem4 = new JMenuItem();
		menuItemNew = new JMenuItem();
		scrollPane2 = new JScrollPane();
		editorPanel = new  JTextArea();

		//======== this ========
		setTitle("Sticky Notes");
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());
		
		setSize(800, 600);
		//======== dialogPane ========
		{
			
			dialogPane.setBorder(new EmptyBorder(12, 12, 12, 12));
			dialogPane.setLayout(new BorderLayout());
			
			//======== contentPanel ========
			{
				contentPanel.setLayout(new BorderLayout());

				//======== scrollPane1 ========
				{

					//---- list1 ----
					list1.addListSelectionListener(e -> list1ValueChanged(e));
					scrollPane1.setViewportView(list1);
				}
				contentPanel.add(scrollPane1, BorderLayout.WEST);

				//======== panel1 ========
				{
					panel1.setLayout(new FlowLayout(FlowLayout.RIGHT));

					//---- button1 ----
					button1.setText("Save");
					button1.addActionListener(e -> button1ActionPerformed(e));
					panel1.add(button1);

					//---- button2 ----
					button2.setText("Login");
					button2.addActionListener(e -> button2ActionPerformed(e));
					panel1.add(button2);
				}
				contentPanel.add(panel1, BorderLayout.SOUTH);

				//======== menuBar1 ========
				{

					//======== menu1 ========
					{
						menu1.setText("File");

						//---- menuItem1 ----
						
						menuItemNew.setText("New");
						menuItemNew.addActionListener(e -> menuNewActionPerformed(e));
						menu1.add(menuItemNew);
						
						menuItem1.setText("Delete");
						menuItem1.addActionListener(e -> menuItem1ActionPerformed(e));
						menu1.add(menuItem1);

						//---- menuItem2 ----
						menuItem2.setText("Logout");
						menuItem2.addActionListener(e -> menuItem2ActionPerformed(e));
						menu1.add(menuItem2);
					}
					menuBar1.add(menu1);

					//======== menu2 ========
					{
						menu2.setText("Edit");

						//---- menuItem3 ----
						menuItem3.setText("Copy");
						menuItem3.addActionListener(e -> menuItem3ActionPerformed(e));
						menu2.add(menuItem3);

						//---- menuItem4 ----
						menuItem4.setText("Paste");
						menuItem4.addActionListener(e -> menuItem4ActionPerformed(e));
						menu2.add(menuItem4);

					}
					menuBar1.add(menu2);

				}
				contentPanel.add(menuBar1, BorderLayout.NORTH);

				//======== scrollPane2 ========
				{
					scrollPane2.setViewportView(editorPanel);
				}
				contentPanel.add(scrollPane2, BorderLayout.CENTER);
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);
		}
		contentPane.add(dialogPane, BorderLayout.CENTER);
		
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	// Generated using JFormDesigner Evaluation license - mario marin
	private JPanel dialogPane;
	private JPanel contentPanel;
	public JScrollPane scrollPane1;
	public JList list1;
	private JPanel panel1;
	private JButton button1;
	private JButton button2;
	private JMenuBar menuBar1;
	private JMenu menu1;
	private JMenuItem menuItem1;
	private JMenuItem menuItem2;
	private JMenu menu2;
	private JMenuItem menuItem3;
	private JMenuItem menuItem4;
	private JMenuItem menuItemNew;
	private JScrollPane scrollPane2;
	private JTextArea editorPanel;
	static public String openFile;
	public boolean is_a_file_open = false;
	static public int stop=0;
	public ArrayList data ;
	private Archivo datos;
	public ArrayList content;
	public ArrayList id;
	// JFormDesigner - End of variables declaration  //GEN-END:variables
}
